#    Adelmo De Santis - PHP code to display rtl_433 sensors data
#    Copyright (C) 2019 Adelmo De Santis

#	 Based on a work from jcarduino https://github.com/jcarduino/rtl_433_2db
#	 https://github.com/jcarduino

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <https://www.gnu.org/licenses/>.






# Please create a mysql database for user rtl433db with create rights so table can be created
# change ip for database server
# install mysql connector
# install phython 2.7
# let it run ;)
#!/usr/bin/python
#import sys
import subprocess
import time
import threading
import Queue
import mysql.connector
import json
import re
from mysql.connector import errorcode

config = {
  'user': 'username',
  'password': 'password',
  'host': 'localhost',
  'database': 'weather',
  'raise_on_warnings': True,
}



class AsynchronousFileReader(threading.Thread):
    '''
    Helper class to implement asynchronous reading of a file
    in a separate thread. Pushes read lines on a queue to
    be consumed in another thread.
    '''

    def __init__(self, fd, queue):
        assert isinstance(queue, Queue.Queue)
        assert callable(fd.readline)
        threading.Thread.__init__(self)
        self._fd = fd
        self._queue = queue

    def run(self):
        '''The body of the tread: read lines and put them on the queue.'''
        for line in iter(self._fd.readline, ''):
            self._queue.put(line)

    def eof(self):
        '''Check whether there is no more content to expect.'''
        return not self.is_alive() and self._queue.empty()

def replace(string):
    while '  ' in string:
        string = string.replace('  ', ' ')
    return string




def startsubprocess(command):
    '''
    Example of how to consume standard output and standard error of
    a subprocess asynchronously without risk on deadlocking.
    '''
    print "\n\nStarting sub process " + command + "\n"
    # Launch the command as subprocess.

    process = subprocess.Popen(command, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)

    # Launch the asynchronous readers of the process' stdout and stderr.
    stdout_queue = Queue.Queue()
    stdout_reader = AsynchronousFileReader(process.stdout, stdout_queue)
    stdout_reader.start()
    stderr_queue = Queue.Queue()
    stderr_reader = AsynchronousFileReader(process.stderr, stderr_queue)
    stderr_reader.start()
    # do database stuff init
    try:
        print("Connecting to database")
        cnx = mysql.connector.connect(**config)
        print("Connection ok")
    except mysql.connector.Error as err:
        if err.errno == errorcode.ER_ACCESS_DENIED_ERROR:
            print("Something is wrong with your user name or password")
        elif err.errno == errorcode.ER_BAD_DB_ERROR:
            print("Database does not exists, please create it before using this script.")
        else:
            print(err) 
    cursor = cnx.cursor()
    while not stdout_reader.eof() or not stderr_reader.eof():
        # Show what we received from standard output.
        modello="undefined"
        id="000"
        temperatura=0.0
        umidita=0.0
        wind_degrees=0.0
        wind_avg=0.0
        wind_gust=0.0
        rainfall=0.0
        rssi=0.0
        snr=0.0
        noise=0.0
        freq=0.0
        pressure=0.0
        null=0
        while not stdout_queue.empty():
            #file_log=open('/var/log/rtl_433.log','a')
            line = stdout_queue.get()
            #file_log.write(repr(line))
            with open('/var/log/rtl_433.log','a') as file_log:
                print >> file_log,line            
            #print repr(line)
            loaded_json = json.loads(line)
            for x in loaded_json:
                print("%s: %s" % (x, loaded_json[x]))
                if x == 'model' :
                    modello=loaded_json[x]
                    modello=modello.replace(" ","_")
                if x == 'id' :
                    id=loaded_json[x]
                elif x == 'sid' :
                    id=loaded_json[x]
                elif x == 'code' :
                    id=loaded_json[x]
                if x == 'temperature_C' :
                    temperatura=loaded_json[x]
                if x == 'humidity' :
                    umidita=loaded_json[x]
                if x == 'direction_deg' :
                    wind_degrees=loaded_json[x]
                if x == 'speed' :
                    wind_avg=loaded_json[x]
                if x == 'gust' :
                    wind_gust=loaded_json[x]
                if x == 'rain' :
                    rainfall=loaded_json[x]
                if x == 'rssi' :
                    rssi=loaded_json[x]
                if x == 'snr' :        
                    snr=loaded_json[x]
                if x == 'noise' :
                    noise=loaded_json[x]
                if x == 'freq' :
                    freq=loaded_json[x]
                if x == 'press' :
                    pressure=loaded_json[x]
            print("\n")
            print("Debug modello: %s %s" % (x, modello))
            print("Debug id: %s %s" % (x, id))
            print("Debug temp: %s %s" % (x, temperatura))
            print("Debug umi: %s %s" % (x, umidita))
            print("Debug wind gradi: %s %s" % (x, wind_degrees))
            print("Debug wind raffica: %s %s" % (x, wind_gust))
            print("Debug wind speed: %s %s" % (x, wind_avg))
            print("Debug rain: %s %s" % (x, rainfall))
            print("Debug rssi: %s %s" % (x, rssi))
            print("Debug snr: %s %s" % (x, snr))
            print("Debug noise: %s %s" % (x, noise))
            print("Debug freq: %s %s" % (x, freq))
            time.sleep(.1)
            print("\n")
            try:
                print("Debug inserimento dati nel DB")
                print("Debug - anno: %s" % (year))
                add_sensordata= ("INSERT INTO remotesensors_2019 (temperatura,umidita,pressione,dewpoint,direzione,velocita,massimo,pioggia,sensore,error,rssi,snr,noise,freq) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)")
                sensordata = (temperatura,umidita,pressure,null,wind_degrees,wind_avg,wind_gust,rainfall,modello,null,rssi,snr,noise,freq)
                cursor.execute(add_sensordata,sensordata)
                add_sensordata= ("INSERT INTO remotesensors_temp (temperatura,umidita,pressione,dewpoint,direzione,velocita,massimo,pioggia,sensore,error,rssi,snr,noise,freq) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)")
                sensordata = (temperatura,umidita,pressure,null,wind_degrees,wind_avg,wind_gust,rainfall,modello,null,rssi,snr,noise,freq)
                cursor.execute(add_sensordata,sensordata)
                cnx.commit()
                file_log.close()
            except mysql.connector.Error as err:
                print(err) 
                cnx.reconnect()
    stdout_reader.join()
    stderr_reader.join()

    # Close subprocess' file descriptors.
    process.stdout.close()
    process.stderr.close()


if __name__ == '__main__':
    # The main flow:
        #check if database is present, create tablesif no tables present

    year, month, day, hour, minute = time.strftime("%Y,%m,%d,%H,%M").split(',')
    startsubprocess("rtl_433 -F json -M hires -M level -s 1024k")
    print("Closing down")
